package com.example.witsystem_device_plugin.SDK.vibrate;

import android.content.Context;
import android.os.Vibrator;


/**
 * 震动
 */
public class Vibrate {

    private static Vibrate vibrate;

    private final Vibrator vibrator;

    public static Vibrate getInstance(Context context) {
        if (vibrate == null) {
            synchronized (Vibrate.class) {
                if (vibrate == null) {
                    vibrate = new Vibrate(context);
                }
            }
        }
        return vibrate;
    }


    private Vibrate(Context context) {
        vibrator = (Vibrator) context.getApplicationContext().getSystemService(Context.VIBRATOR_SERVICE);
    }



    /**
     * 开始震动
     */
    public void start() {
        vibrator.vibrate(800);
    }

    /**
     * 自定义震动
     *
     * @param pattern
     * @param repeat
     */
    public void start(long[] pattern, int repeat) {
        vibrator.vibrate(pattern, repeat);
    }


    /**
     * 停止震动
     */
    public void stop() {
        if (vibrator != null) vibrator.cancel();
    }


}
