//
// Created by wits on 2022/5/25.
//

import Foundation
import Flutter

import WitsystemIosSDK
///设备信息发生变化

public class DeviceChangeHandler : NSObject, FlutterStreamHandler {

    private var stateNumber : Int? = nil;
    private var deviceManage : DeviceManage? = nil

    public func onListen(withArguments arguments: Any?, eventSink events: @escaping FlutterEventSink) -> FlutterError? {
        do {
            deviceManage = try WitsystemIosSDK.witsystemIosSDK.getDeviceManage()
            if (stateNumber != nil) {
                deviceManage!.removeObserver(index: stateNumber!)
            }
            stateNumber = deviceManage!.addObserver { devices in
                events(String(data: try! JSONEncoder().encode(devices),encoding: .utf8));
            }
        } catch let err {
            let notInitialized: NotInitialized = err as! NotInitialized
            events(FlutterError(code: notInitialized.code.description, message: notInitialized.error, details: nil));
        }
        print("启动设备变化监听《《《《《《《《《《《《");
        return nil;
    }

    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        if (stateNumber != nil && deviceManage != nil) {
            deviceManage!.removeObserver(index: stateNumber!)
        }
        stateNumber = nil;
        print("关闭设备变化监听《《《《《《《《《《《《");
        return nil;
    }


}
